<?php
require_once(__DIR__."/../apl_config.php");
require_once(__DIR__."/../apl_ver.php");
require_once(__DIR__."/../apl_settings.php");
require_once(__DIR__."/login_check.php");


$page_title="Customize Emails";
$page_message="Customize reminder emails about expiring license, updates, and support. All variables surrounded by % sign will be automatically converted into real values in email messages (HTML tags are supported).<br><br>For more information on supported variables, refer to the Help section.";
$page_message_class="alert alert-info";
$page_header_file_no_data="index.php";


$action_success=0; //will be changed to 1 later only if everything OK
$error_detected=0; //will be changed to 1 later if error occurs
$error_details=null; //will be filled with errors (if any)
$added_records=0;
$updated_records=0;
$removed_records=0;


$email_id=1; //manually set email_id because no other ids should be available


if (!empty($_POST) && is_array($_POST) && array_walk($_POST, "sanitizeSubmittedData", array("script_filename"=>$script_filename, "html_fields"=>$FORM_FIELDS_WITH_TAGS))) //sanitize super variable with all POST values
    {
    extract($_POST, EXTR_SKIP); //extract sanitized data (don't overwrite existing variables)
    }


if (empty($email_id) || !filter_var($email_id, FILTER_VALIDATE_INT) || empty($rows_array=fetchRow("SELECT * FROM apl_emails WHERE email_id=?", array($email_id), array("i")))) //invalid record
    {
    header("Location: $page_header_file_no_data");
    exit();
    }


if (!isset($submit_ok)) //extract fetched variables only if form wasn't submitted (otherwise data entered by user will be overwritten with data from database in case of form submission failure)
    {
    foreach ($rows_array as $row)
        {
        extract($row);
        }
    }


if (isset($submit_ok))
    {
    if (!empty($email_expiring_license_subject) && !empty($email_expiring_license_text) && !empty($email_expiring_updates_subject) && !empty($email_expiring_updates_text) && !empty($email_expiring_support_subject) && !empty($email_expiring_support_text))
        {
        if ($error_detected!=1)
            {
            $updated_records=updateRow("UPDATE apl_emails SET email_expiring_license_subject=?, email_expiring_license_text=?, email_expiring_updates_subject=?, email_expiring_updates_text=?, email_expiring_support_subject=?, email_expiring_support_text=?", array($email_expiring_license_subject, $email_expiring_license_text, $email_expiring_updates_subject, $email_expiring_updates_text, $email_expiring_support_subject, $email_expiring_support_text), array("s", "s", "s", "s", "s", "s"));
            if ($updated_records<1)
                {
                $error_detected=1;
                $error_details.="Invalid record details or duplicated record (no new data).<br>";
                }
            else
                {
                $action_success=1;
                }
            }
        }
    else
        {
        $error_detected=1;
        $error_details.="Invalid message(s).<br>";
        }

    if ($action_success==1) //everything OK
        {
        $page_message="Email messages updated.";
        createReport(strip_tags($page_message), $logged_admin_id, 1, $error_detected);
        $page_message_class="alert alert-success";
        }
    else //display error message
        {
        $page_message="The database could not be updated because of this error: <br><br>$error_details";
        $page_message_class="alert alert-danger";
        }
    }


//Twig templating starts
if (!isset($script_filename)) {$script_filename=basename($_SERVER['SCRIPT_FILENAME']);} //if $script_filename is not set yet (usually set in login_check.php), get it now (will be used in Twig forms)

Twig_Autoloader::register();
$loader=new Twig_Loader_Filesystem("../apl_templates"); //load files from templates directory
$twig=new Twig_Environment($loader); //create Twig environment

$twig->addExtension(new \nochso\HtmlCompressTwig\Extension());

echo $twig->render(basename(__DIR__)."/".basename(__FILE__, ".php").".twig", get_defined_vars()); //render requested template
//Twig templating ends
