<?php
require_once(__DIR__."/../apl_config.php");
require_once(__DIR__."/../apl_ver.php");
require_once(__DIR__."/../apl_settings.php");


//get IP, refer, requested page, script filename, and user agent (browser)
if (isset($_SERVER['REMOTE_ADDR'])) {$ip_address=$_SERVER['REMOTE_ADDR'];}
if (isset($_SERVER['HTTP_REFERER'])) {$refer=$_SERVER['HTTP_REFERER'];}
if (isset($_SERVER['REQUEST_URI'])) {$requested_page=$_SERVER['REQUEST_URI'];}
if (isset($_SERVER['SCRIPT_FILENAME'])) {$script_filename=basename($_SERVER['SCRIPT_FILENAME']);}
if (isset($_SERVER['HTTP_USER_AGENT'])) {$user_agent=$_SERVER['HTTP_USER_AGENT'];}


if (!empty($_POST)) //filter all $_POST requests submitted to /apl_admin
    {
    $_POST=filterFormPostRequest($_POST, $ROOT_URL, basename(__DIR__), $refer);
    }


$is_logged_in_admin=false; //will be changed to true if login credentials verification succeeds


if (isset($_COOKIE[COOKIE_PREFIX."_admin_id"]) && isset($_COOKIE[COOKIE_PREFIX."_admin_email"]) && isset($_COOKIE[COOKIE_PREFIX."_admin_key"]) && isset($_COOKIE[COOKIE_PREFIX."_admin_data_authenticity"])) //login cookie set
    {
    $cookie_admin_id=$_COOKIE[COOKIE_PREFIX."_admin_id"]; //id
    $cookie_admin_email=$_COOKIE[COOKIE_PREFIX."_admin_email"]; //email (encrypted with password_hash)
    $cookie_admin_key=$_COOKIE[COOKIE_PREFIX."_admin_key"]; //key (id, email and password hash) (encrypted with password_hash)
    $cookie_admin_data_authenticity=$_COOKIE[COOKIE_PREFIX."_admin_data_authenticity"]; //user agent and IP (encrypted with password_hash)

    if (filter_var($cookie_admin_id, FILTER_VALIDATE_INT) && !empty($cookie_admin_email) && !empty($cookie_admin_key)) //authentication data exists
        {
        $rows_array=fetchRow("SELECT * FROM apl_admins WHERE admin_id=?", array($cookie_admin_id), array("i"));
        foreach ($rows_array as $row)
            {
            extract($row, EXTR_PREFIX_ALL, "logged"); //add prefix 'logged'

            if ($logged_admin_id==$cookie_admin_id && password_verify($logged_admin_email, $cookie_admin_email) && password_verify($logged_admin_id.$logged_admin_email.$logged_admin_password, $cookie_admin_key)) //everything ok
                {
                $is_logged_in_admin=true;
                }

            if ($logged_admin_data_authenticity==1 && !password_verify($ip_address.$user_agent, $cookie_admin_data_authenticity)) //additional data authentication enabled, perform additional checks and set login to failed if needed
                {
                $is_logged_in_admin=false;
                }
            }
        }
    }


if ($is_logged_in_admin!==true && !in_array($script_filename, $ANONYMOUS_FILES_ARRAY)) //login credentials verification failed and requested page can't be viewed anonymously, redirect to login form
    {
    if (empty($requested_page)) {$requested_page="index.php";}
    setcookie(COOKIE_PREFIX."_requested_page", $requested_page, 0, null, null, null, true); //cookie with requested page, valid until browser is closed
    header("Location: login.php");
    exit();
    }


if ($is_logged_in_admin===true) //login check succeeded
    {
    $twig_rss_feeds_array=parseDisplayRss($NEWS_TEXT, "https://www.phpmillion.com/feed", $NEWS_DATE, 1, 3); //load RSS feed
    $twig_sidebar_items_array=returnLeftMenuArray($script_filename); //load sidebar menu
    }
