<?php
require_once(__DIR__."/../apl_config.php");
require_once(__DIR__."/../apl_ver.php");
require_once(__DIR__."/../apl_settings.php");
require_once(__DIR__."/login_check.php");


if ($is_logged_in_admin===true) //redirect to the dashboard if logged in
    {
    header("Location: index.php");
    exit();
    }


$page_title="Lost Password";
$page_message="Enter your email address.";
$page_message_class="alert alert-info";


$action_success=0; //will be changed to 1 later only if everything OK
$error_detected=0; //will be changed to 1 later if error occurs
$error_details=null; //will be filled with errors (if any)
$added_records=0;
$updated_records=0;
$removed_records=0;


if (!empty($_POST) && is_array($_POST) && array_walk($_POST, "sanitizeSubmittedData", array("script_filename"=>$script_filename, "html_fields"=>$FORM_FIELDS_WITH_TAGS))) //sanitize super variable with all POST values
    {
    extract($_POST, EXTR_SKIP); //extract sanitized data (don't overwrite existing variables)
    }


if (isset($submit_ok))
    {
    if (filter_var($admin_email, FILTER_VALIDATE_EMAIL))
        {
        $rows_array=fetchRow("SELECT * FROM apl_admins WHERE admin_email=?", array($admin_email), array("s"));
        if (!empty($rows_array))
            {
            foreach ($rows_array as $row)
                {
                extract($row, EXTR_PREFIX_ALL, "logged"); //add prefix 'logged'

                $logged_admin_reset=hash("sha256", microtime().$logged_admin_email);

                $updated_records=updateRow("UPDATE apl_admins SET admin_reset=? WHERE admin_id=?", array($logged_admin_reset, $logged_admin_id), array("s", "i"));
                if ($updated_records>0)
                    {
                    $mailer_result=emailAdmin("Password Recovery", "Someone at <a href='$ROOT_URL/apl_admin/'>$ROOT_URL/apl_admin/</a> requested admin password to be reset. If you lost your password, <a href='$ROOT_URL/apl_admin/login_resetpassword.php?admin_reset=$logged_admin_reset'>click this link</a> to reset it. If for some reasons the link doesn't work, copy/paste it manually into your browser - $ROOT_URL/apl_admin/login_resetpassword.php?admin_reset=$logged_admin_reset<br><br><b>Attention:</b>If you have never requested admin password to be reset, simply ignore and delete this email - your account is 100% secure.");
                    if (filter_var($mailer_result, FILTER_VALIDATE_INT))
                        {
                        $action_success=1;
                        }
                    else
                        {
                        $error_detected=1;
                        $error_details.="mail() function failure on server.<br>";
                        }
                    }
                }
            }
        else
            {
            $error_detected=1;
            $error_details.="Invalid email address.<br>";
            }
        }
    else
        {
        $error_detected=1;
        $error_details.="Invalid email address.<br>";
        }

    if ($action_success==1) //everything OK
        {
        $page_message="Password recovery instructions sent to $logged_admin_email.";
        createReport(strip_tags($page_message), 0, 1, 0);
        $page_message_class="alert alert-success";
        }
    else //display error message
        {
        $page_message="Password recovery failed because of this error: <br><br>$error_details";
        $page_message_class="alert alert-danger";
        }
    }


//Twig templating starts
if (!isset($script_filename)) {$script_filename=basename($_SERVER['SCRIPT_FILENAME']);} //if $script_filename is not set yet (usually set in login_check.php), get it now (will be used in Twig forms)

Twig_Autoloader::register();
$loader=new Twig_Loader_Filesystem("../apl_templates"); //load files from templates directory
$twig=new Twig_Environment($loader); //create Twig environment

$twig->addExtension(new \nochso\HtmlCompressTwig\Extension());

echo $twig->render(basename(__DIR__)."/".basename(__FILE__, ".php").".twig", get_defined_vars()); //render requested template
//Twig templating ends
