<?php
require_once(__DIR__."/../apl_config.php");
require_once(__DIR__."/../apl_ver.php");
require_once(__DIR__."/../apl_settings.php");
require_once(__DIR__."/login_check.php");


if ($is_logged_in_admin===true) //redirect to the dashboard if logged in
    {
    header("Location: index.php");
    exit();
    }


$page_title="Reset Password";
$page_message="Enter new password.";
$page_message_class="alert alert-info";


$action_success=0; //will be changed to 1 later only if everything OK
$error_detected=0; //will be changed to 1 later if error occurs
$error_details=null; //will be filled with errors (if any)
$added_records=0;
$updated_records=0;
$removed_records=0;


if (!empty($_GET) && is_array($_GET) && array_walk($_GET, "sanitizeSubmittedData", array("script_filename"=>$script_filename, "html_fields"=>$FORM_FIELDS_WITH_TAGS))) //sanitize super variable with all GET values
    {
    extract($_GET, EXTR_SKIP); //extract sanitized data (don't overwrite existing variables)
    }


if (!empty($_POST) && is_array($_POST) && array_walk($_POST, "sanitizeSubmittedData", array("script_filename"=>$script_filename, "html_fields"=>$FORM_FIELDS_WITH_TAGS))) //sanitize super variable with all POST values
    {
    extract($_POST, EXTR_SKIP); //extract sanitized data (don't overwrite existing variables)
    }


if (empty($admin_reset))
    {
    header("Location: login.php");
    exit();
    }


if (isset($submit_ok))
    {
    if (!empty($admin_reset) && !empty($admin_password) && !empty($admin_password2) && $admin_password==$admin_password2 && strlen($admin_password)>5)
        {
        $rows_array=fetchRow("SELECT * FROM apl_admins WHERE admin_reset=?", array($admin_reset), array("s"));
        if (!empty($rows_array))
            {
            foreach ($rows_array as $row)
                {
                extract($row, EXTR_PREFIX_ALL, "logged"); //add prefix 'logged'

                $logged_admin_password=password_hash($admin_password, PASSWORD_DEFAULT);
                $logged_admin_reset=null;

                $updated_records=updateRow("UPDATE apl_admins SET admin_password=?, admin_reset=? WHERE admin_id=?", array($logged_admin_password, $logged_admin_reset, $logged_admin_id), array("s", "s", "i"));
                if ($updated_records<1)
                    {
                    $error_detected=1;
                    $error_details.="Invalid record details or duplicated record (no new data).<br>";
                    }
                else
                    {
                    $action_success=1;
                    }
                }
            }
        else //admin doesn't exist
            {
            $error_detected=1;
            $error_details.="Invalid security key.<br>";
            }
        }
    else
        {
        $error_detected=1;
        $error_details.="Passwords are too short or don't match (or security key is invalid).<br>";
        }

    if ($action_success==1) //everything OK
        {
        $page_message="Password for $logged_admin_email successfully reset.";
        createReport(strip_tags($page_message), $logged_admin_id, 1, $error_detected);
        $page_message_class="alert alert-success";
        }
    else //display error message
        {
        $page_message="The database could not be updated because of this error: <br><br>$error_details";
        $page_message_class="alert alert-danger";
        }
    }


//Twig templating starts
if (!isset($script_filename)) {$script_filename=basename($_SERVER['SCRIPT_FILENAME']);} //if $script_filename is not set yet (usually set in login_check.php), get it now (will be used in Twig forms)

Twig_Autoloader::register();
$loader=new Twig_Loader_Filesystem("../apl_templates"); //load files from templates directory
$twig=new Twig_Environment($loader); //create Twig environment

$twig->addExtension(new \nochso\HtmlCompressTwig\Extension());

echo $twig->render(basename(__DIR__)."/".basename(__FILE__, ".php").".twig", get_defined_vars()); //render requested template
//Twig templating ends
