<?php
require_once(__DIR__."/../apl_config.php");
require_once(__DIR__."/../apl_ver.php");
require_once(__DIR__."/../apl_settings.php");
require_once(__DIR__."/login_check.php");


$page_title="Advanced Settings";
$page_message="Configure advanced software settings, enable and disable individual options.";
$page_message_class="alert alert-info";


$action_success=0; //will be changed to 1 later only if everything OK
$error_detected=0; //will be changed to 1 later if error occurs
$error_details=null; //will be filled with errors (if any)
$added_records=0;
$updated_records=0;
$removed_records=0;


if (!empty($_POST) && is_array($_POST) && array_walk($_POST, "sanitizeSubmittedData", array("script_filename"=>$script_filename, "html_fields"=>$FORM_FIELDS_WITH_TAGS))) //sanitize super variable with all POST values
    {
    extract($_POST, EXTR_SKIP); //extract sanitized data (don't overwrite existing variables)
    }


if (isset($submit_ok))
    {
    if (validateNumberOrRange($api_status, 0, 1) && validateNumberOrRange($banned_hosts, 0, 1))
        {
        if ($error_detected!=1)
            {
            $updated_records=updateRow("UPDATE apl_settings SET API_STATUS=?, BANNED_HOSTS=?, ENVATO_API_TOKEN=?", array($api_status, $banned_hosts, $envato_api_token), array("i", "i", "s"));
            if ($updated_records<1)
                {
                $error_detected=1;
                $error_details.="Invalid settings or duplicated record (no new data).<br>";
                }
            else
                {
                $action_success=1;
                }
            }
        }
    else
        {
        $error_detected=1;
        $error_details.="Invalid settings.<br>";
        }

    if ($action_success==1) //everything OK
        {
        $page_message="Advanced software settings updated.";
        createReport(strip_tags($page_message), $logged_admin_id, 1, $error_detected);
        $page_message_class="alert alert-success";
        }
    else //display error message
        {
        $page_message="The database could not be updated because of this error: <br><br>$error_details";
        $page_message_class="alert alert-danger";
        }


    //get all settings again
    $rows_array=fetchRow("SELECT * FROM apl_settings");
    foreach ($rows_array as $row)
        {
        extract($row);
        }
    }


//set default values for essential variables (mostly submitted to dropdown functions) when no values are set or values need to be reset
if (!empty($envato_api_token))
    {
    $ENVATO_API_TOKEN=$envato_api_token;
    }


//Twig templating starts
if (!isset($script_filename)) {$script_filename=basename($_SERVER['SCRIPT_FILENAME']);} //if $script_filename is not set yet (usually set in login_check.php), get it now (will be used in Twig forms)

Twig_Autoloader::register();
$loader=new Twig_Loader_Filesystem("../apl_templates"); //load files from templates directory
$twig=new Twig_Environment($loader); //create Twig environment

$twig->addExtension(new \nochso\HtmlCompressTwig\Extension());

echo $twig->render(basename(__DIR__)."/".basename(__FILE__, ".php").".twig", get_defined_vars()); //render requested template
//Twig templating ends
