<?php
error_reporting(E_ALL);

//get script's root directory
define("SCRIPT_ROOT_DIRECTORY", __DIR__);

//load extra libraries
require_once(SCRIPT_ROOT_DIRECTORY."/apl_modules/phpmillion_core.php");
require_once(SCRIPT_ROOT_DIRECTORY."/apl_modules/phpmillion_modules.php");
require_once(SCRIPT_ROOT_DIRECTORY."/apl_modules/phpmillion_plugins.php");
require_once(SCRIPT_ROOT_DIRECTORY."/apl_modules/phpmillion_plugins_gui.php");
require_once(SCRIPT_ROOT_DIRECTORY."/apl_modules/apl_core_configuration.php");
require_once(SCRIPT_ROOT_DIRECTORY."/apl_modules/apl_core_functions.php");
require_once(SCRIPT_ROOT_DIRECTORY."/lib/swiftmailer/swift_required.php");
require_once(SCRIPT_ROOT_DIRECTORY."/lib/Twig/Autoloader.php");
require_once(SCRIPT_ROOT_DIRECTORY."/lib/html-compress-twig/autoload.php");

//get all settings
$rows_array=fetchRow("SELECT * FROM apl_settings");
foreach ($rows_array as $row)
    {
    extract($row);
    }

//set timezone
date_default_timezone_set($TIMEZONE);

//cookie for login system
define("COOKIE_PREFIX", "apl");

//supported browsers array (internal requests only coming from these browsers will be processed. do not modify yourself!)
$SUPPORTED_BROWSERS_ARRAY=array("Mozilla/5.0 (Windows NT 6.3; WOW64; rv:48.0) Gecko/20100101 Firefox/48.0");

//anonymous files array (user will not be forced to login when requesting one of these pages. do not modify yourself!)
$ANONYMOUS_FILES_ARRAY=array("login.php", "login_lostpassword.php", "login_resetpassword.php", "logout.php");

//supported API functions array (only these API calls will be processed)
$SUPPORTED_API_FUNCTIONS_ARRAY=array("banned_hosts_add", "banned_hosts_edit", "clients_add", "clients_edit", "installations_edit", "licenses_add", "licenses_edit", "products_add", "products_edit", "search");

//supported API search types array (only these API search types will be processed)
$SUPPORTED_API_SEARCHES_ARRAY=array("callback", "client", "installation", "license", "product", "report");

//array with form fields that allow HTML-like tags (where key is script filename and value is a sub-array with names of form fields that allow HTML)
$FORM_FIELDS_WITH_TAGS=array("login.php"=>array("admin_password"), "login_resetpassword.php"=>array("admin_password", "admin_password2"), "profile_edit.php"=>array("admin_password_1", "admin_password_2"));

//verify client's license
$license_notifications_array=aplVerifyLicense($GLOBALS["mysqli"]);
if ($license_notifications_array['notification_case']!="notification_license_ok")
    {
    echo $license_notifications_array['notification_text'];
    exit();
    }

//load auto tasks
cleanupDatabase($DATABASE_CLEANUP_ENABLED, $DATABASE_CLEANUP_CALLBACKS, $DATABASE_CLEANUP_REPORTS_MAIN, $DATABASE_CLEANUP_REPORTS_SYSTEM, $DATABASE_CLEANUP_LICENSES, $DATABASE_CLEANUP_DATE); //cleanup database
sendReminderEmails($EMAIL_FROM_NAME, $EMAIL_FROM_ADDRESS, $EMAIL_EXPIRING_LICENSE_DAYS, $EMAIL_EXPIRING_UPDATES_DAYS, $EMAIL_EXPIRING_SUPPORT_DAYS, $EXPIRATION_CHECK_DATE); //send reminder emails

//prevent banned hosts from using system
blockBannedHosts($BANNED_HOSTS);
