<?php
//--//--//apply modifications to config file before executing actual upgrade script - start//--//--//

//version 1.9 added MySQL connection changes - start
$config_file_content=file_get_contents(__DIR__."/apl_config.php");
if (stristr($config_file_content, 'mysqli_connect($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME, $DB_PORT)')===false)
    {
    $config_file_content=str_replace('$DB_HOST=', '$DB_PORT="3306"; //MySQL port'."\n".'$DB_HOST=', $config_file_content);
    $config_file_content=str_replace('mysqli_connect($DB_HOST, $DB_USER, $DB_PASS)', 'mysqli_connect($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME, $DB_PORT)', $config_file_content);
    $config_file_content=str_replace('mysqli_select_db($GLOBALS["mysqli"], $DB_NAME);'."\n".'mysqli_', 'mysqli_', $config_file_content);

    $handle=fopen(__DIR__."/apl_config.php", "w+");
    fwrite($handle, $config_file_content);
    fclose($handle);
    }
//version 1.9 added MySQL connection changes - end

//--//--//apply modifications to config file before executing actual upgrade script - end//--//--//


//contains and executes MySQL upgrade queries for each version, does other upgrade actions if needed
require_once(__DIR__."/apl_config.php");
require_once(__DIR__."/apl_ver.php");
require_once(__DIR__."/apl_settings.php");


//--//--//apply PHP-logic-based modifications to database before executing actual upgrade script - start//--//--//

//version 1.9.1 associated reports with individual products - start
if ($DATABASE_VERSION<"1.9.1")
    {
    $rows_array=fetchRow("SELECT * FROM apl_products ORDER BY CHAR_LENGTH(product_title) DESC");
    if (!empty($rows_array))
        {
        foreach ($rows_array as $row)
            {
            extract($row);

            updateRow("UPDATE apl_reports SET product_id=? WHERE product_id=? AND report_system=? AND report_text LIKE ?", array($product_id, 0, 0, "%$product_title %"), array("i", "i", "i", "s"));
            }
        }
    }
//version 1.9.1 associated reports with individual products - end

//--//--//apply PHP-logic-based modifications to database before executing actual upgrade script - end//--//--//


$mysql_query=null;
$version_number_update_query="UPDATE `apl_settings` SET `DATABASE_VERSION`='$PRODUCT_VERSION';"; //this line will always be added at the end of mysql_query to update DATABASE_VERSION


$database_changes_array=array();
$database_changes_array['1.2']="ALTER TABLE `apl_settings` ADD `DATABASE_VERSION` VARCHAR(250) NOT NULL AFTER `NEWS_DATE`;

ALTER TABLE `apl_licenses` ADD INDEX `client_id` (`client_id`);
ALTER TABLE `apl_licenses` ADD INDEX `product_id` (`product_id`);

ALTER TABLE `apl_installations` ADD INDEX `client_id` (`client_id`);
ALTER TABLE `apl_installations` ADD INDEX `license_code` (`license_code`);
ALTER TABLE `apl_installations` ADD INDEX `product_id` (`product_id`);";

$database_changes_array['1.5']="ALTER TABLE `apl_licenses` CHANGE `license_updates_date` `license_updates_date` DATE NOT NULL DEFAULT '0000-00-00';
ALTER TABLE `apl_licenses` ADD `license_support_date` date NOT NULL DEFAULT '0000-00-00' AFTER `license_updates_date`;
ALTER TABLE `apl_licenses` ADD `license_expire_email_date` date NOT NULL DEFAULT '0000-00-00' AFTER `license_expire_date`;
ALTER TABLE `apl_licenses` ADD `license_updates_email_date` date NOT NULL DEFAULT '0000-00-00' AFTER `license_updates_date`;
ALTER TABLE `apl_licenses` ADD `license_support_email_date` date NOT NULL DEFAULT '0000-00-00' AFTER `license_support_date`;

ALTER TABLE `apl_notifications` ADD `notification_support_expired` VARCHAR(250) NOT NULL AFTER `notification_updates_expired`;
UPDATE `apl_notifications` SET `notification_support_expired`='%PRODUCT_TITLE% support expired on %LICENSE_SUPPORT_DATE%';

CREATE TABLE `apl_emails` (
  `email_id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `email_expiring_license_subject` VARCHAR(125) NOT NULL,
  `email_expiring_license_text` text NOT NULL,
  `email_expiring_updates_subject` VARCHAR(125) NOT NULL,
  `email_expiring_updates_text` text NOT NULL,
  `email_expiring_support_subject` VARCHAR(125) NOT NULL,
  `email_expiring_support_text` text NOT NULL,
  PRIMARY KEY (`email_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

INSERT INTO `apl_emails` (`email_id`, `email_expiring_license_subject`, `email_expiring_license_text`, `email_expiring_updates_subject`, `email_expiring_updates_text`, `email_expiring_support_subject`, `email_expiring_support_text`) VALUES (1, '%PRODUCT_TITLE% License Expiration', 'Dear %CLIENT_FNAME% %CLIENT_LNAME%,\r\n\r\nYour %PRODUCT_TITLE% license expires at %LICENSE_EXPIRE_DATE%. Please renew your license before this date, so you can continue using the software without any interruption.', '%PRODUCT_TITLE% Updates Expiration', 'Dear %CLIENT_FNAME% %CLIENT_LNAME%,\r\n\r\nYour %PRODUCT_TITLE% updates expire at %LICENSE_UPDATES_DATE%. Please renew your updates before this date, so you can continue receiving new versions without any interruption.', '%PRODUCT_TITLE% Support Expiration', 'Dear %CLIENT_FNAME% %CLIENT_LNAME%,\r\n\r\nYour %PRODUCT_TITLE% support expires at %LICENSE_SUPPORT_DATE%. Please renew your support before this date, so you can continue receiving technical assistance without any interruption.');

ALTER TABLE `apl_settings`
ADD `EMAIL_FROM_NAME` VARCHAR(125) NOT NULL AFTER `API_STATUS`,
ADD `EMAIL_FROM_ADDRESS` VARCHAR(125) NOT NULL AFTER `EMAIL_FROM_NAME`,
ADD `EMAIL_EXPIRING_LICENSE_DAYS` SMALLINT(6) NOT NULL AFTER `EMAIL_FROM_ADDRESS`,
ADD `EMAIL_EXPIRING_UPDATES_DAYS` SMALLINT(6) NOT NULL AFTER `EMAIL_EXPIRING_LICENSE_DAYS`,
ADD `EMAIL_EXPIRING_SUPPORT_DAYS` SMALLINT(6) NOT NULL AFTER `EMAIL_EXPIRING_UPDATES_DAYS`,
ADD `EXPIRATION_CHECK_DATE` date NOT NULL AFTER `EMAIL_EXPIRING_SUPPORT_DAYS`;

UPDATE `apl_settings` SET `EMAIL_FROM_NAME`='Auto PHP Licenser', `EMAIL_FROM_ADDRESS`='$CLIENT_EMAIL', `EMAIL_EXPIRING_LICENSE_DAYS`='0', `EMAIL_EXPIRING_UPDATES_DAYS`='0', `EMAIL_EXPIRING_SUPPORT_DAYS`='0', `EXPIRATION_CHECK_DATE`='".date("Y-m-d")."';";

$database_changes_array['1.6.1']="ALTER TABLE `apl_settings` DROP `DATABASE_CLEANUP_DAYS`;
ALTER TABLE `apl_settings` ADD `DATABASE_CLEANUP_ENABLED` TINYINT(1) NOT NULL AFTER `EXPIRATION_CHECK_DATE`;
ALTER TABLE `apl_settings` CHANGE `DATABASE_CLEANUP_CALLBACKS` `DATABASE_CLEANUP_CALLBACKS` SMALLINT(6) NOT NULL;
ALTER TABLE `apl_settings` CHANGE `DATABASE_CLEANUP_REPORTS` `DATABASE_CLEANUP_REPORTS` SMALLINT(6) NOT NULL;
ALTER TABLE `apl_settings` CHANGE `DATABASE_CLEANUP_LICENSES` `DATABASE_CLEANUP_LICENSES` SMALLINT(6) NOT NULL;

UPDATE `apl_settings` SET `DATABASE_CLEANUP_ENABLED`='1', `DATABASE_CLEANUP_CALLBACKS`='90', `DATABASE_CLEANUP_REPORTS`='90', `DATABASE_CLEANUP_LICENSES`='0';";

$database_changes_array['1.8']="CREATE TABLE `apl_banned_hosts` (
  `banned_host_id` mediumint(9) NOT NULL AUTO_INCREMENT,
  `banned_host_ip` varchar(125) NOT NULL,
  `banned_host_comments` varchar(250) NOT NULL,
  `banned_host_date` date NOT NULL,
  `banned_host_blocks` mediumint(9) NOT NULL,
  `banned_host_block_date` date NOT NULL,
  PRIMARY KEY (`banned_host_id`),
  UNIQUE KEY `banned_host_ip` (`banned_host_ip`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE `apl_licenses` CHANGE `license_active_date` `license_date` DATE NOT NULL;

ALTER TABLE `apl_notifications` ADD `notification_host_banned` varchar(250) NOT NULL AFTER `notification_invalid_signature`;

UPDATE `apl_notifications` SET `notification_host_banned`='Hostname %IP_ADDRESS% is banned';

ALTER TABLE `apl_settings` CHANGE `DATABASE_CLEANUP_CALLBACKS` `DATABASE_CLEANUP_CALLBACKS` SMALLINT(6) NOT NULL;
ALTER TABLE `apl_settings` CHANGE `DATABASE_CLEANUP_REPORTS` `DATABASE_CLEANUP_REPORTS` SMALLINT(6) NOT NULL;
ALTER TABLE `apl_settings` CHANGE `DATABASE_CLEANUP_LICENSES` `DATABASE_CLEANUP_LICENSES` SMALLINT(6) NOT NULL;
ALTER TABLE `apl_settings` ADD `RECORDS_ON_SEARCH_PAGE` MEDIUMINT(9) NOT NULL AFTER `RECORDS_ON_INDEX_PAGE`;
ALTER TABLE `apl_settings` ADD `BANNED_HOSTS` TINYINT(1) NOT NULL AFTER `API_STATUS`;
ALTER TABLE `apl_settings` ADD `SMART_REPORTS` TINYINT(1) NOT NULL AFTER `BANNED_HOSTS`;

UPDATE `apl_settings` SET `RECORDS_ON_SEARCH_PAGE`='100', `BANNED_HOSTS`='1', `SMART_REPORTS`='1';

ALTER TABLE `apl_notifications` DROP `notification_product_inactive`;";

$database_changes_array['1.9']="ALTER TABLE `apl_admins` CHANGE `admin_password` `admin_password` VARCHAR(125) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

ALTER TABLE `apl_api_keys` CHANGE `api_key_secret` `api_key_secret` VARCHAR(125) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

ALTER TABLE `apl_callbacks` ADD KEY (`product_id`);

ALTER TABLE `apl_installations` ADD KEY (`installation_ip`);
ALTER TABLE `apl_installations` ADD KEY (`installation_domain`);
ALTER TABLE `apl_installations` CHANGE `installation_hash` `installation_hash` VARCHAR(125) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

ALTER TABLE `apl_licenses` ADD `license_envato` TINYINT(1) NOT NULL DEFAULT '0' AFTER `license_comments`;

ALTER TABLE `apl_products` ADD `product_envato_id` INT NULL AFTER `product_version`;
ALTER TABLE `apl_products` ADD UNIQUE (`product_envato_id`);
ALTER TABLE `apl_products` CHANGE `product_url_homepage` `product_url_homepage` VARCHAR(125) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `apl_products` CHANGE `product_url_download` `product_url_download` VARCHAR(125) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;

ALTER TABLE `apl_reports` ADD `product_id` MEDIUMINT(9) NOT NULL AFTER `report_id`;
ALTER TABLE `apl_reports` ADD KEY (`account_id`);
ALTER TABLE `apl_reports` ADD KEY (`product_id`);
ALTER TABLE `apl_reports` ADD KEY (`license_code`);

ALTER TABLE `apl_settings` ADD `ENVATO_API_TOKEN` varchar(125) NOT NULL AFTER `NEWS_DATE`;
ALTER TABLE `apl_settings` CHANGE `ROOT_URL` `ROOT_URL` VARCHAR(125) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `apl_settings` CHANGE `CLIENT_EMAIL` `CLIENT_EMAIL` VARCHAR(125) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `apl_settings` CHANGE `LICENSE_CODE` `LICENSE_CODE` VARCHAR(125) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;
ALTER TABLE `apl_settings` CHANGE `INSTALLATION_HASH` `INSTALLATION_HASH` VARCHAR(125) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL;";

$database_changes_array['1.9.1']="ALTER TABLE `apl_settings` ADD `SMART_TABLES` TINYINT(1) NOT NULL AFTER `SMART_REPORTS`;
ALTER TABLE `apl_settings` ADD `DATABASE_CLEANUP_REPORTS_SYSTEM` SMALLINT(6) NOT NULL AFTER `DATABASE_CLEANUP_REPORTS`;
ALTER TABLE `apl_settings` CHANGE `DATABASE_CLEANUP_REPORTS` `DATABASE_CLEANUP_REPORTS_MAIN` SMALLINT(6) NOT NULL;

UPDATE `apl_settings` SET `SMART_TABLES`='1', `DATABASE_CLEANUP_REPORTS_SYSTEM`='60';";


foreach ($database_changes_array as $change_version=>$change_query) //merge database changes for each version into single query
    {
    if ($change_version>$DATABASE_VERSION)
        {
        $mysql_query.=$change_query."\n";
        }
    }


if ($DATABASE_VERSION<$PRODUCT_VERSION) //execute query only if upgrade needs to be performed
    {
    $mysql_query.=$version_number_update_query; //add final line to update DATABASE_VERSION


    mysqli_close($GLOBALS["mysqli"]); //close MySQL connection and connect again to prevent errors when mysqli_query is executed again
    sleep(1);

    $GLOBALS["mysqli"]=mysqli_connect($DB_HOST, $DB_USER, $DB_PASS, $DB_NAME, $DB_PORT);
    mysqli_query($GLOBALS["mysqli"], "SET SESSION sql_mode='NO_ENGINE_SUBSTITUTION'");
    mysqli_set_charset($GLOBALS["mysqli"], "utf8");

    mysqli_multi_query($GLOBALS["mysqli"], $mysql_query) or die(mysqli_error($GLOBALS["mysqli"]));
    echo "<upgrade>$PRODUCT_VERSION</upgrade>"; //if script wasn't aborted by die() function above, it means everything was just fine
    }
else //the latest version is installed or upgrade already performed
    {
    echo "<installed>$DATABASE_VERSION</installed>";
    }
